from abc import abstractmethod, ABCMeta

class TAMScriptModule(object):
    """
    Abstract class which TAMSCript Modules must implement.
    While all modules must respond to GetTileTypes calls (even if only with a super() call),
    the GetSeed method is optional.
    """
    __metaclass__ = ABCMeta
    
    
    def Is3D(self):
        return False

    #  GetSeed is the function called by the simulator to get the definitions and
    #  locations of tiles in the seed
    def GetSeed(self):
        return set()
    
    #  GetTileTypes is the function called by the simulator as it encounters frontier locations
    @abstractmethod
    def GetTileTypes(self,nbrGlues):
        return set()