#version 330

uniform mat4 u_ProjectionMatrix = mat4(1.0);
uniform mat4 u_ViewMatrix = mat4(1.0);

//uniform ivec3 u_TileOffset = ivec3(0, 0, 0);

layout (location = 0) in vec3  a_Position;
layout (location = 1) in vec3  a_Normal;
layout (location = 2) in ivec3 a_TileOffset;
layout (location = 3) in ivec3 a_Color;

out vec4 v_Position; // in camera coordinates
out vec4 v_Normal;
out vec4 v_Color;

const float TILE_SIZE = 0.5;

void main()
{
    v_Position = u_ProjectionMatrix * u_ViewMatrix * vec4(a_Position + vec3(a_TileOffset), 1.0) * TILE_SIZE;
    gl_Position = v_Position;

    v_Normal = normalize(u_ProjectionMatrix * u_ViewMatrix * vec4(a_Normal, 0.0));
    v_Color = vec4(vec3(a_Color), 255.0) / 255.0;
}